#ifndef SCENE_H
#define SCENE_H

#include <QObject>
#include <QtOpenGL>
#include <QGLFunctions>
#include <QOpenGLFunctions>

#include <scenenode.h>
#include <sceneobject.h>
#include <sceneprimitive.h>

class Scene: public QObject // QAbstractItemModel
{
    Q_OBJECT
public:
    Scene();
    void draw();

    int simpleScene();


    void moveActive(QVector3D dir);
    void rotateActive(QQuaternion rot);

    SceneObject *getActive();
    SceneObject *setActive(int id);


//    QVariant data(const QModelIndex &index, int role) const Q_DECL_OVERRIDE;
//   Qt::ItemFlags flags(const QModelIndex &index) const Q_DECL_OVERRIDE;
//   QVariant headerData(int section, Qt::Orientation orientation,
//                       int role = Qt::DisplayRole) const Q_DECL_OVERRIDE;
//   QModelIndex index(int row, int column,
//                     const QModelIndex &parent = QModelIndex()) const Q_DECL_OVERRIDE;
//   QModelIndex parent(const QModelIndex &index) const Q_DECL_OVERRIDE;
//   int rowCount(const QModelIndex &parent = QModelIndex()) const Q_DECL_OVERRIDE;
//   int columnCount(const QModelIndex &parent = QModelIndex()) const Q_DECL_OVERRIDE;

    int tesselation;
public slots:
     void setTesselation(int tesselation);
     ScenePrimitive *addCube();
     ScenePrimitive *addSphere();
     ScenePrimitive *addCylinder();
     ScenePrimitive *addTorus();
     ScenePrimitive *addCone();

signals:
    void activChanged();

private:
    SceneNode *root;
    SceneObject *active;


    SceneNode *getRoot();


};

#endif // SCENE_H
